<?php

/*
        This PHP code is a part of EDPXY web service
        Copyright (C) 2018 DDS Central

        This source code is a property of DDS Central.
        Unauthorized distribution and use of this code is strictly prohibited.

	Author grants permission to use this code separately from EDPXY and Phoenix web services.

        Playlist retriever for LRT.LT
*/

require_once("config/lrtconfig.php");
require_once("func/proxyutils.php");

function generate_error($caption, $text)
{
	echo "<!doctype html>\n";
	echo "<html>\n";
	echo "<head>\n";
	echo "<title>$caption</title>\n";
	echo "</head>\n";
	echo "<body>\n";
	echo "<h1>$caption</h1>\n";
	echo "<div>$text</div>\n";
	echo "</body>\n";
	echo "</html>";
}

function get_script_output($script, $param)
{
	$prog     = "$script";
	$descr    = [0 => ['pipe','r'], 1 => ['pipe','w'], 2 =>['pipe','w']];
	$pipes    = [];
	$process  = proc_open($prog, $descr, $pipes);

	if (is_resource($process))
	{
		fputs($pipes[0], $param . PHP_EOL);
		fclose($pipes[0]);

		$result = stream_get_contents($pipes[1]);
		$errors = stream_get_contents($pipes[2]);

		fclose($pipes[1]);
		fclose($pipes[2]);

		proc_close($process);
	}

	return $result;
}

$request = get_request_under_script();

if (strlen($request) == 0)
{
	return;
}

$request_parts = explode('/', $request);

$filename = isset($request_parts[1]) ? $request_parts[1] : '';

$filename_extension = explode('.', $filename);

$extension = isset($filename_extension[1]) ? $filename_extension[1] : '';

if ($extension != 'm3u8')
{
	return;
}

$channel = isset($filename_extension[0]) ? $filename_extension[0] : '';

$playlist = get_script_output(INTTV_SCRIPT, $channel);

$length = strlen($playlist);

if ($length == 0)
{
	header("HTTP/1.0 500 Internal Server Error");
	generate_error("500 - Internal Server Error", "Could not retrieve playlist.");

	return;
}

header("Content-Type: application/vnd.apple.mpegurl");
header("Content-Length: $length");

echo "$playlist";
